#include <stdint.h>
#include <stdio.h>
#include <string.h> 
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include "receive.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>

/* Max lenght String*/
#define Ns 5 
/*Max  lenght Array*/
#define Nz 8  
/*baudrate=38400*/
#define baud               7
/*baudrate=9600*/
//#define baud               32 
/*the formula for calculate the UBBR0 value is 
 *  UBBR0= F_CPU/(16*baud)-1
*/


char tempstr[200];
char string[200];
char buffer[200];
unsigned char nextCharPos;
int lendekryptString;
const char dekryptString[200];
volatile unsigned char stringReady;

/*the formula for calculate the UBBR0 value is 
 *  UBBR0= F_CPU/(16*baud)-1
*/
void USART0_Init (void){
	uint8_t intstate = SREG;
	cli();

	while(0<<TXC0){
	}
	/* set baud rate*/
	UBRR0H = (uint8_t)(baud>>8);
	UBRR0L = (uint8_t)(baud);

	/* set frame format: I wil set it now as 8 bits, no parity 1 stop bit, asynchron*/
	UCSR0C = (0<<UMSEL0)|(0<<UPM0)|(0<<USBS0)|(3<<UCSZ0);
	/*Enable receiver and transmitter; enable RX interrupt*/
	UCSR0B = (1<<TXEN0)|(1<<RXEN0)|(1<<RXCIE0);
	sprintf(tempstr, "UBRR0H: 0x%x,UBRR0L: 0x%x", UBRR0H,UBRR0L);
	break_point(tempstr, __LINE__);
	SREG=intstate;
}

void dekrypt_data_cpu()
{
	
	int len_dekryptString;
	// char data_format[Nz][Ns];
	char FrameFormat[Nz][Ns];
	len_dekryptString=strlen(dekryptString);
	const char *delims= " "; 
	char **test[50];			
	char *result=NULL; // initialisieren des Pointers
	result = strtok_r( dekryptString,delims,test); // sucht  Leerzeichen imString str
	int sPtr=0;

	while( result != NULL ) 
	{
		strcpy(FrameFormat[sPtr],result);
		result = strtok_r( NULL, delims,test );
		sPtr++;
	}
	for(int i=0;i<sPtr;i++)
	{
    		sprintf(tempstr," frame: %s\n, %d",FrameFormat[i]);
    		break_point(tempstr, __LINE__);
	}
}


ISR (SIG_UART0_RECV)
{  
	unsigned char c = UDR0;

	if( c == '\r' ) {  // ist der String vollständig?
		
		string[nextCharPos] = '\0';    
		stringReady = 1;
		nextCharPos = 0;
	}

	else {
		string[nextCharPos] = c;
		nextCharPos++;
	}
}

void break_point(char *str, uint8_t v) 
{
	int a,b=10;
	a=b+2+v;

	return;

}


